#!/bin/sh

# Usage: /common/svmconf/rungauss.sh dataset output
# dataset is in DENSE format (to be compatible with LEMGA)

current=`pwd`
tool=`dirname $current/$0`
name=`basename $1`
infile=$1
outfile=$2
tmp=/tmp/$$
SVMDIR=$tool/libsvm-2.8

mkdir $tmp
python $tool/dense2sparse.py $infile > $tmp/$name.sparse
cd $tmp
DISPLAY='' python $SVMDIR/tools/grid.py -svmtrain $SVMDIR/svm-train -t 2 -m 256 -v 5 $name.sparse > $name.gauss.cv
param=`tail -n 1 < $name.gauss.cv`
C=`echo $param | awk '{print $1}'`
g=`echo $param | awk '{print $2}'`

$SVMDIR/svm-train -t 2 -m 256 -g $g -c $C $name.sparse $name.gauss.model

$SVMDIR/svm-predict-margins $name.sparse $name.gauss.model $name.gauss.margins

cd $current

cp $tmp/$name.gauss.margins $outfile

rm -rf $tmp
